<?php
class AdminClearccscacheController extends ModuleAdminController
{
    public function __construct()
    {
        parent::__construct();
        $this->bootstrap = true;
        if (isset($_GET['action']) &&  $_GET['action']=='sendCurlRequest' ){
          $this->sendCurlRequest();
        }
    }

    public function init()
    {
        parent::init();
    }

    public function initContent()
    {
        parent::initContent();
        $this->context->smarty->assign(array());
        $this->setTemplate('origin.tpl');
    }
    /**
     * This method triggers the clearccscache cache on the ccs servers
     * Steps:
     * 1. Get the URL from user input
     * 2. Get the radio value from user input
     * 3. Parse the response
     * 4. Make a cURL request to that url + "/json"
     * 5. Check how many servers are
     * 6. For each server we make another cURL by admin n_x where x is the server number
     * 7. Check if the server_response contains 'Successful purge'
     * 8. Show messages
     */
    public function sendCurlRequest(){

        /** step1 */
        $url = Configuration::get('CCS_CLEAR_CACHE_URL');
        /** step2 */
        $choice = Configuration::get('DELETE_POST_CACHE');
        /** step3 */
        if($choice == 1 ){
            /** step4 */
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url.'/json' );
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $contents = curl_exec($ch);
            curl_close($ch);
            /** step5 */
            $contents_decode = json_decode($contents);
            /** step6 */
            $notice = null;
            if($contents_decode->cc_paths->has_servers >= 1){
                foreach($contents_decode->cc_paths->server_paths as $path ){
                    $url_server = $contents_decode->cc_paths->base_url.$path;
                    $ch_server = curl_init();
                    curl_setopt( $ch_server, CURLOPT_URL, $url_server );
                    curl_setopt($ch_server, CURLOPT_RETURNTRANSFER, 1);
                    $server_response = curl_exec( $ch_server);
                    curl_close( $ch_server);
                    /** step7 */
                    $findme   = 'Successful purge';
                    $pos = strpos($server_response, $findme);
                    /** step8 */
                    if ($pos === false) {
                          $notice = $this->errors[] = "Cache could not be cleared";
                    } else {
                         $notice = $this->confirmations[] = "Cache was cleared";
                    }
                }
                return $notice ;
            }
        }
    }
}
?>